class.NPC(Entity)

function NPC:__init(x, y, c, ai)

	self.pos = Vec2(x, y)
	self.col = c
	self.solid = true
	self.ai = ai or AI()
	RegisterEnt(self, "NPC")

end

function NPC:SetPos(x, y)

	self.pos.x = x
	self.pos.y = y
	SetPixel(x, y, self.col)

end

function NPC:Move(x, y)

	local nx, ny = self.pos.x + x, self.pos.y + y
	if not Vec2(nx, ny):InGrid() then return end
	for k, v in pairs(ents) do
	
		if v.pos == Vec2(nx, ny) and v.solid then return end
	
	end
	self:SetPos(nx, ny)

end

function NPC:Draw()

	SetPixel(self.pos.x, self.pos.y, self.col)

end

function NPC:Tick()

	self.ai:Tick(self)

end

function NPC:Use(p)

	self.ai:Use(self, p)

end

function NPC:Activate(x, y)

	local nx, ny = self.pos.x + x, self.pos.y + y
	if not Vec2(nx, ny):InGrid() then return end
	local ent
	for k, v in pairs(ents) do
	
		if v.Use and v.pos == Vec2(nx, ny) then ent = v break end
	
	end
	if not ent then return end
	ent:Use(self)

end