class.Player(Entity)

function Player:__init(x, y, c)

	self.pos = Vec2(x, y)
	self.col = c
	self.solid = true
	RegisterEnt(self, "player")
	hook.Call("PlayerCreate", self)

end

function Player:SetPos(x, y)

	self.pos.x = x
	self.pos.y = y
	SetPixel(x, y, self.col)

end

function Player:Move(x, y)

	hook.Call("PlayerMove", self)
	local nx, ny = self.pos.x + x, self.pos.y + y
	if not Vec2(nx, ny):InGrid() then return end
	for k, v in pairs(ents) do
	
		if v.pos == Vec2(nx, ny) and v.solid then return end
	
	end
	self:SetPos(nx, ny)
	local np = view:ToPixCoords(view.pos)
	if (self.pos.x < np.x + 5 and x < 0 and np.x > 0) or (self.pos.x > np.x + vw - 5 and x > 0 and np.x + vw - 5 < gw - 5) or (self.pos.y < np.y + 5 and y < 0 and np.y > 0) or (self.pos.y > np.y + vh - 5 and y > 0 and np.y + vh - 5 < gh - 5) then
		view:Translate(Vec2(x * pw, y * ph))
	end

end

function Player:Draw()

	hook.Call("PlayerDraw", self)
	SetPixel(self.pos.x, self.pos.y, self.col)

end

function Player:Tick()

	hook.Call("PlayerTick", self)
	if love.keyboard.isDown("d") then
		self:Move(1, 0)
	elseif love.keyboard.isDown("a") then
		self:Move(-1, 0)
	elseif love.keyboard.isDown("s") then
		self:Move(0, 1)
	elseif love.keyboard.isDown("w") then
		self:Move(0, -1)
	end

end

function Player:Activate(x, y)

	local nx, ny = self.pos.x + x, self.pos.y + y
	if not Vec2(nx, ny):InGrid() then return end
	local ent
	for k, v in pairs(ents) do
	
		if v.Use and v.pos == Vec2(nx, ny) then ent = v break end
	
	end
	if not ent then return end
	ent:Use(self)
	hook.Call("PlayerUse", self, ent)

end