class.WallPiece(Entity)

function WallPiece:__init(x, y, c)

	self.pos = Vec2(x, y)
	self.col = c
	self.solid = true
	RegisterEnt(self, "wall")

end

function WallPiece:Draw()

	SetPixel(self.pos.x, self.pos.y, self.col)

end

class.Wall()

function Wall:__init(sx, sy, ex, ey, c)

	self.p = {}
	for k, v in pairs(Vec2(sx, sy):BreshLine(Vec2(ex, ey))) do
	
		table.insert(self.p, WallPiece(v.x, v.y, c))
	
	end

end

class.Door(Entity)

function Door:__init(x, y, c)

	self.pos = Vec2(x, y)
	self.col = c
	self.solid = true
	RegisterEnt(self, "door")

end

function Door:Open(t)

	self.solid = not t

end

function Door:Draw()

	if self.solid then
		SetPixel(self.pos.x, self.pos.y, self.col)
	else
		SetPixel(self.pos.x, self.pos.y, Color(self.col.r, self.col.g, self.col.b, 100))
	end

end

function Door:Use()

	self:Open(self.solid)

end

class.SeizureBlock(Entity)

function SeizureBlock:__init(x, y)

	self.pos = Vec2(x, y)
	self.col = c
	self.solid = true
	RegisterEnt(self, "wall")

end

function SeizureBlock:Draw()

	SetPixel(self.pos.x, self.pos.y, RandomColor())

end